%define gstreamername gstreamer1
%global __python %{__python3}

Name: @PACKAGE_NAME@
Version: @PACKAGE_VERSION@
Release: 1%{?dist}
Summary: GSTLAL Experimental Supplements
License: GPL
Group: LSC Software/Data Analysis

# --- package requirements --- #
Requires: gstlal >= @MIN_GSTLAL_VERSION@
Requires: gstlal-ugly >= @MIN_GSTLALUGLY_VERSION@
Requires: gobject-introspection >= @MIN_GOBJECT_INTROSPECTION_VERSION@
Requires: %{gstreamername} >= @MIN_GSTREAMER_VERSION@
Requires: %{gstreamername}-plugins-base >= @MIN_GSTREAMER_VERSION@
Requires: %{gstreamername}-plugins-good >= @MIN_GSTREAMER_VERSION@
Requires: %{gstreamername}-plugins-bad-free
Requires: gsl

# --- LSCSoft package requirements --- #
Requires: lal >= @MIN_LAL_VERSION@
Requires: lalmetaio >= @MIN_LALMETAIO_VERSION@
Requires: lalinspiral >= @MIN_LALINSPIRAL_VERSION@
Requires: ligo-gracedb >= 2.7.5
Requires: ligo-scald >= @MIN_LIGO_SCALD_VERSION@
Requires: python3 >= @MIN_PYTHON_VERSION@
Requires: python%{python3_pkgversion}-%{gstreamername}
Requires: python%{python3_pkgversion}-gwdatafind
Requires: python%{python3_pkgversion}-lal >= @MIN_LAL_VERSION@
Requires: python%{python3_pkgversion}-lalinspiral >= @MIN_LALINSPIRAL_VERSION@
Requires: python%{python3_pkgversion}-ligo-lw >= @MIN_LIGO_LW_VERSION@
Requires: python%{python3_pkgversion}-ligo-lw-bin >= @MIN_LIGO_LW_VERSION@
Requires: python%{python3_pkgversion}-ligo-segments >= @MIN_LIGO_SEGMENTS_VERSION@
Requires: python%{python3_pkgversion}-ligo-scald >= @MIN_LIGO_SCALD_VERSION@

# --- python package requirements --- #
Requires: python%{python3_pkgversion}-tqdm
Requires: python%{python3_pkgversion}-numpy >= @MIN_NUMPY_VERSION@
Requires: python%{python3_pkgversion}-scipy
Requires: python%{python3_pkgversion}-h5py

%if 0%{?rhel} == 8
Requires: python%{python3_pkgversion}-numpy >= @MIN_NUMPY_VERSION@
Requires: python3-matplotlib
%else
Requires: numpy >= @MIN_NUMPY_VERSION@
Requires: python%{python3_pkgversion}-matplotlib
%endif

# --- build requirements
BuildRequires: doxygen >= @MIN_DOXYGEN_VERSION@
BuildRequires: gobject-introspection-devel >= @MIN_GOBJECT_INTROSPECTION_VERSION@
BuildRequires: graphviz
BuildRequires: gstlal-devel >= @MIN_GSTLAL_VERSION@
BuildRequires: %{gstreamername}-devel >= @MIN_GSTREAMER_VERSION@
BuildRequires: %{gstreamername}-plugins-base-devel >= @MIN_GSTREAMER_VERSION@
BuildRequires: gsl-devel
BuildRequires: gtk-doc >= @MIN_GTK_DOC_VERSION@
BuildRequires: liblal-devel >= @MIN_LAL_VERSION@
BuildRequires: liblalmetaio-devel >= @MIN_LALMETAIO_VERSION@
BuildRequires: liblalinspiral-devel >= @MIN_LALINSPIRAL_VERSION@
BuildRequires: pkgconfig >= @MIN_PKG_CONFIG_VERSION@
BuildRequires: python3-devel >= @MIN_PYTHON_VERSION@
BuildRequires: python%{python3_pkgversion}-lal >= @MIN_LAL_VERSION@
BuildRequires: python%{python3_pkgversion}-lalinspiral >= @MIN_LALINSPIRAL_VERSION@
Source: https://software.igwn.org/lscsoft/source/@PACKAGE_NAME@-%{version}.tar.gz
URL: https://git.ligo.org/lscsoft/gstlal
Packager: Kipp Cannon <kipp.cannon@ligo.org>
BuildRoot: %{_tmppath}/%{name}-%{version}-root
%description
This package provides a variety of gstreamer elements for
gravitational-wave data analysis and some libraries to help write such
elements.  The code here sits on top of several other libraries, notably
the LIGO Algorithm Library (LAL), FFTW, the GNU Scientific Library (GSL),
and, of course, GStreamer.

This package contains plugins, libraries, and programs for inspiral data
analysis.


%package devel
Summary: Files and documentation needed for compiling gstlal-inspiral based plugins and programs.
Group: LSC Software/Data Analysis
Requires: gstlal-devel >= @MIN_GSTLAL_VERSION@ 
Requires: python3-devel >= @MIN_PYTHON_VERSION@ 
Requires: %{gstreamername}-devel >= @MIN_GSTREAMER_VERSION@ 
Requires: %{gstreamername}-plugins-base-devel >= @MIN_GSTREAMER_VERSION@ 
Requires: liblal-devel >= @MIN_LAL_VERSION@ 
Requires: liblalmetaio-devel >= @MIN_LALMETAIO_VERSION@ 
Requires: liblalinspiral-devel >= @MIN_LALINSPIRAL_VERSION@ 
Requires: gsl-devel
%description devel
This package contains the files needed for building gstlal-inspiral based
plugins and programs.


%prep
%setup -q -n %{name}-%{version}


%build
%configure --enable-gtk-doc --disable-massmodel PYTHON=python3
%{__make}


%install
# FIXME:  why doesn't % makeinstall macro work?
DESTDIR=${RPM_BUILD_ROOT} %{__make} install
# remove .so symlinks from libdir.  these are not included in the .rpm,
# they will be installed by ldconfig in the post-install script, except for
# the .so symlink which isn't created by ldconfig and gets shipped in the
# devel package
[ ${RPM_BUILD_ROOT} != "/" ] && find ${RPM_BUILD_ROOT}/%{_libdir} -name "*.so.*" -type l -delete
# don't distribute *.la files
[ ${RPM_BUILD_ROOT} != "/" ] && find ${RPM_BUILD_ROOT} -name "*.la" -type f -delete


%post
if test -d /usr/lib64 ; then
	ldconfig /usr/lib64
else
	ldconfig
fi


%postun
if test -d /usr/lib64 ; then
	ldconfig /usr/lib64
else
	ldconfig
fi


%clean
[ ${RPM_BUILD_ROOT} != "/" ] && rm -Rf ${RPM_BUILD_ROOT}
rm -Rf ${RPM_BUILD_DIR}/%{name}-%{version}


%files
%defattr(-,root,root)
%{_bindir}/*
%{_datadir}/gstlal/*
%{_docdir}/gstlal-inspiral-*
%{_libdir}/*.so.*
%{_libdir}/gstreamer-@GSTREAMER_RELEASE@/*.so
#%{_libdir}/gstreamer-@GSTREAMER_RELEASE@/python/*
%{_prefix}/%{_lib}/python*/site-packages/gstlal

%files devel
%defattr(-,root,root)
%{_libdir}/*.a
%{_libdir}/*.so
%{_libdir}/gstreamer-@GSTREAMER_RELEASE@/*.a
%{_libdir}/pkgconfig/*
%{_includedir}/*
